#!/usr/bin/perl

# $Id$

use strict;

sub {
    my ($rda, $plugintype, $datafile, $datatype) = @_;

    my $archive = $rda->archive() or do {
        $rda->logging(4,
            'Can get archive'
        );
        return(0);
    };
   
    my $filename = $archive->extract() or do {
        $rda->logging(4,
            "Can't get temporary file: %s",
            $archive->error,
        );
        return(0);
    };
    
    my $resopen = open(my $h, $filename);
    
    unlink($filename);

    if (!$resopen) {
        $rda->logging(4,
            "Can't open temp file %s",
            $filename,
        );
        return(0);
    }

    while (my $line = <$h>) {
        chomp($line);
        if ($line =~ /^Numero\s+\|Nom\s+\|Voies actives/) {
            my $nextline = <$h>;
            chomp($nextline);
            $nextline =~ /^1\s*\|E(\d)\d{6}\.?N\d{4}/;
            if ($1) {
                return(1,
                    'mode', $1,
                );
            } else {
                $rda->logging(4,
                    "can't find marker: %s",
                    $nextline,
                );
                return(0);
            }
        }
    }

    close($h);
    
    return(0);
}

