/**************************************************************************/
/*                                                                        */
/* nom du fichier: insere.c                                              */
/*                                                                        */
/* Utilitaire permettant d'inserer des fichiers de donnees                */
/* Dumont D'Urville dans la base de donnees                               */
/* Verifier que les fichiers .bat sont bien a jour                        */
/* genere des fichiers .log d'execution de la procedure                   */
/*                                                                        */
/* by P.GENAU                                                             */
/*                                                                        */
/**************************************************************************/

#include<stdio.h>
#include<string.h>
#include <time.h>
#include <ftw.h>
#include <stdlib.h>
#include <unistd.h>
	/* access() */

#include "constantes.h"
#include "typedef.h"


STFICH *debut,*fin,*fiche;

STFICH2 *debut2,*fin2,*fiche2;

static char *moism[]={"janvier","fevrier","mars","avril","mai","juin","juillet","aout",
	"septembre","octobre","novembre","decembre"};

char rep_base[255];
        /* repertoire de travail de base */


/*** LES FONCTIONS ***/
/*   -------------   */

int test_type(nomfich,type)
char *nomfich,*type;
{
int trouve;
char delim[2],*arg1,*strtok(),*token;
char type2[255];

strcpy(type2,type);
arg1=type2;
trouve=1;
strcpy(delim,"*");
while((token=strtok(arg1,delim)) != NULL)
	{
	if(strstr(nomfich,token) == NULL)
		trouve = 0;
	arg1=NULL;
	};
return(trouve);

}


int recup_rep(nomfich,type,rep,type_rep_final,codage)
char nomfich[255],type[25],*rep,*type_rep_final,*codage;
{
int bool_fin;

bool_fin = FAUX;
fiche2 = debut2;
while(bool_fin == FAUX)
	{
	if ( test_type(nomfich,fiche2->type) == 1 )
		{
		bool_fin = VRAI;
		strcpy(type,fiche2->type);
		strcpy(rep,fiche2->rep);
		strcpy(type_rep_final,fiche2->type_rep_final);
		strcpy(codage,fiche2->codage);
		}

	else if ( fiche2 == fin2)
		return(-1);

	else
		fiche2 = fiche2->suivant;
		/* on passe a la fich suivante */
	};
return(0);
};



/*** PROGRAMME PRICIPAL ***/
/*   ------------------   */

main(argc,argv)
int argc;
char *argv[];
{
STSAISIEPARAM saisie; /* structure contenant les infos utilisateur */
FILE *fp_insert,*fp_attente,*fp_maj,*fp_type,*fp_menu,*fp_ohp;
FILE *fp_mail;
char nomfich[255],commande[100],c_date[10],annee[3];
char rep[255],type[25],codage[50],rep_base_stock[255];
int param;
int retour_prepare;
int date;
	/* date des donnees du fichier en traitement */
char type_rep_final[255];
char sujet[100];
char destinataires[100];

int erreur,i;

struct tm *tmptr,tmvar;
time_t nseconds;
char *ptr;
char date_depouil[35];

char *buf,*buf2;

printf("\n*** Insertion des donnees DUMONT D'URVILLE");
printf("\n    Version: %5.3g\n",VERSION);
printf("    date   : %d\n",DATE_VERSION);

if(getenv("TRAIT_DDU") != NULL)
	strcpy(rep_base,getenv("TRAIT_DDU"));
else
	strcpy(rep_base,"/ndsc/prog/adelie");

/* saisie des parametres */
/* --------------------- */
saisie_param(&saisie,argc,argv);

if(saisie.repprog[0] != 0)
	sprintf(rep_base,"%s",saisie.repprog);

/* calcul de la date courante */
nseconds=time(NULL);
ptr=ctime(&nseconds);
i=0;
while( ptr[i] != '\n' )
        date_depouil[i++]=ptr[i];
date_depouil[i]=0;


fp_mail=fopen("stockage.dat","w");

fprintf(fp_mail,"		Compte rendu d'Archivage des donnes Dumont D'Urville\n");
if(saisie.decompress == VRAI)
	fprintf(fp_mail,"		pour: %s du %s:\n",saisie.fich_trans,saisie.date_fich_compress);
else
 	fprintf(fp_mail,"		du %s:\n",date_depouil);

fprintf(fp_mail,"		-----------------------------\n\n");


/* stockage des fichiers en attente et du fichier compresse */
/* -------------------------------------------------------- */
fp_attente=fopen("attente.dat","r");
if(fp_attente != NULL)
	{
	while(fscanf(fp_attente,"%s",nomfich) != EOF)
		{
		sprintf(commande,"cp \"%s\" %s/",nomfich,rep_base);
		if(strstr(nomfich,".lzh") != NULL)
			strcat(commande,"lzh");
		else
			strcat(commande,"attente");
		system(commande);
		printf("%s\n",commande);
		fprintf(fp_mail,"%s\n",commande);
		};
	fclose(fp_attente);
	};
	
fp_ohp=fopen("ohp.dat","r");
if(fp_ohp != NULL)
	{
	while(fscanf(fp_ohp,"%s",nomfich) != EOF)
		{
		sprintf(commande,"cp \"%s\" %s/ohp",nomfich,rep_base);
		system(commande);
		printf("%s\n",commande);
		fprintf(fp_mail,"%s\n",commande);
		};
	fclose(fp_ohp);
	};


/* lecture des repertoires de stockage */
/* ----------------------------------- */
debut2 = NULL;
fin2 = NULL;
codage[0]=0;
sprintf(commande,"%s/stock_rep.dat",rep_base);
fp_type=fopen(commande,"r");
while(fscanf(fp_type,"%s%s%s",type,rep,type_rep_final) != EOF)
	{
		if(debut2 == 0)
		{
		/* on cree la structure */
		debut2 = malloc((size_t)sizeof(struct st2) );
		debut2->suivant=debut2;
		debut2->precedant=debut2;
		fin2=debut2;
		/* on y copie les infos */
		strcpy(debut2->type,type);
		strcpy(debut2->rep,rep);
		strcpy(debut2->type_rep_final,type_rep_final);
		strcpy(debut2->codage,codage);

		}

	else
		{
		fin2->suivant=malloc((size_t)sizeof(struct st2) );
		fin2->suivant->precedant=fin2;
		fin2 = fin2->suivant;

		/* on y copie les infos */
		strcpy(fin2->type,type);
		strcpy(fin2->rep,rep);
		strcpy(fin2->type_rep_final,type_rep_final);
		strcpy(fin2->codage,codage);
		};
	};
fclose(fp_type);


/* stockage des fichiers a inserer dans la base */
/* -------------------------------------------- */
debut = NULL;
fin = NULL;
fp_insert=fopen("insert.dat","r");
if (fp_insert != NULL)
	{
	while(fscanf(fp_insert,"%s%s",nomfich,c_date) != EOF)
		{

		if(recup_rep(nomfich,type,rep,type_rep_final,codage) != -1)
			{
			/* copie fichier dans repertoire de stockage */
			date=atoi(c_date);
			retour_prepare=prepare_rep_stock(date,rep,type_rep_final);
				/* on cree les repertoires annee, mois, jour si necessaire. */
				/* complete le repertoire de stockage rep_base_stock. */
				/* retour = 0 : OK */
				/*         -1 : erreur */
			if( retour_prepare == 0)	
				{

 				/* on recupere le nom du fichier sans l'arborescence */
				/* et on teste on existance dans le repertoire de stockage */
    			buf=nomfich;
				while((buf2=(strstr(buf,"/")))!=NULL)
					{
					buf=buf2;
					buf++;
					};

           		 sprintf(commande,"%s/%s",rep,buf);
				if(access(commande,F_OK) == -1 || saisie.forcer == VRAI)
				/* si le fichier n'existe pas dans le repertoire de stockage */
					{
					// fprintf(fp_mail,"%s\n",commande);
					/* on le copie dans le repertoire */
					sprintf(commande,"cp \"%s\" %s",nomfich,rep);
					system(commande);
					printf("%s\n",commande);
                                	buf=nomfich;
                                	while((buf2=(strstr(buf,"/")))!=NULL)
                                        	{
                                        	buf=buf2;
                                        	buf++;
                                        	};
					fprintf(fp_mail,"%s/%s\n",rep,buf);
					}
				else
					{
					/* on previent que le fichier n'est pas stock */
					printf("*** ATTENTION: %s existe\n",commande);
					printf("     %s non stock!\n",nomfich);
					};

				}
			else
				{
				sprintf(commande,"cp \"%s\" %s/attente",nomfich,rep_base);
				system(commande);
				printf("%s\n",commande);
    				buf=nomfich;
				while((buf2=(strstr(buf,"/")))!=NULL)
					{
					buf=buf2;
					buf++;
					};
				fprintf(fp_mail,"%s/attente%s\n",rep_base,buf);
				};
			

			}
		else
			{
			printf("PAS D'INFO pour inserer %s !\n",nomfich);
			sprintf(commande,"cp \"%s\" %s/attente",nomfich,rep_base);
			system(commande);
			printf("%s\n",commande);
    			buf=nomfich;
			while((buf2=(strstr(buf,"/")))!=NULL)
				{
				buf=buf2;
				buf++;
				};
			fprintf(fp_mail,"%s/attente%s\n",rep_base,buf);
			};
		
		};

	};

fclose(fp_mail);

if(saisie.mail == VRAI && saisie.decompress == VRAI)
	{
	strcpy(nomfich,"stockage.dat");
   	 buf=saisie.fich_trans;
	while((buf2=(strstr(buf,"/")))!=NULL)
		{
		buf=buf2;
		buf++;
		};
	sprintf(sujet,"CR Archivage %s du %s",buf,saisie.date_fich_compress);
	sprintf(destinataires,"%s/mail_users.dat",rep_base);
	envoi_mail(nomfich,sujet,destinataires);
	};

}
